#ifndef TESTLOGGER_H
#define TESTLOGGER_H

#include <iostream>
#include <fstream>
#include <vector>

#include "code/ISnuviLogger.h"

class TestLogger : public ISnuviLogger
{
public:
    TestLogger();
    ~TestLogger();
    
    void print(
            const std::string* message = nullptr, 
            const std::exception* ex = nullptr, 
            const std::string* function = nullptr, 
            const std::string* scriptname = nullptr, 
            const Script* sc = nullptr,
            int line = -1) override;
    
    void reset();
    bool check(const std::string& name, std::ifstream& check);

private:
    void printNoMatch(const std::string& name, std::vector<std::string>& file, unsigned int line);
    
    std::vector<std::string> output;
};

#endif