#ifndef TOKEN_H
#define TOKEN_H

#include "tokenizer/TokenType.h"

class Token final
{
public:
    Token(TokenType tt, unsigned int line, const std::string& text, double number);
    Token(TokenType tt, unsigned int line);
    Token(TokenType tt, unsigned int line, double number);
    Token(TokenType tt, unsigned int line, const std::string& text);
    
    TokenType getType() const;
    int getLine() const;
    
    std::string toString() const;
    
private:
    TokenType type;
    unsigned int line;
    std::string text;
    double number;
};

#endif